package ru.bitheaven.createairfabric.mixin;

import com.simibubi.create.content.equipment.armor.BacktankUtil;
import com.simibubi.create.content.equipment.armor.DivingHelmetItem;

import earth.terrarium.adastra.common.items.armor.SpaceSuitItem;
import earth.terrarium.adastra.common.systems.OxygenApiImpl;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;

@Mixin(OxygenApiImpl.class)
public abstract class EntityOxygenSystemMixin {
    /**
     * Make air exists if Create Air
     */
    @Redirect(at = @At(value = "INVOKE", target = "Learth/terrarium/adastra/common/items/armor/SpaceSuitItem;hasOxygen(Lnet/minecraft/world/entity/Entity;)Z"),
            method = "entityTick(Lnet/minecraft/server/level/ServerLevel;Lnet/minecraft/world/entity/LivingEntity;)V")
    private boolean redirectOxygenTick(Entity entity) {
        if (!(entity instanceof LivingEntity livingEntity)) return SpaceSuitItem.hasOxygen(entity);
        boolean createOxygen = true;
        createOxygen &= !DivingHelmetItem.getWornItem(livingEntity).isEmpty();
        createOxygen &= !BacktankUtil.getAllWithAir(livingEntity).isEmpty();
        return SpaceSuitItem.hasOxygen(livingEntity) || createOxygen;
    }
}
